
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Makefile documentation &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Report a bug" href="report.html" />
    <link rel="prev" title="Changelog" href="changelog.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="report.html" title="Report a bug"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="changelog.html" title="Changelog"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="makefile-documentation">
<h1>Makefile documentation<a class="headerlink" href="#makefile-documentation" title="Permalink to this headline">¶</a></h1>
<p>Makefile is used to automate Pyroute2 deployment and test
processes. Mostly, it is but a collection of common commands.</p>
<div class="section" id="target-clean">
<h2>target: clean<a class="headerlink" href="#target-clean" title="Permalink to this headline">¶</a></h2>
<p>Clean up the repo directory from the built documentation,
collected coverage data, compiled bytecode etc.</p>
</div>
<div class="section" id="target-docs">
<h2>target: docs<a class="headerlink" href="#target-docs" title="Permalink to this headline">¶</a></h2>
<p>Build documentation. Requires <cite>sphinx</cite>.</p>
</div>
<div class="section" id="target-test">
<h2>target: test<a class="headerlink" href="#target-test" title="Permalink to this headline">¶</a></h2>
<p>Run tests against current code. Command line options:</p>
<ul class="simple">
<li><p>python – path to the Python to use</p></li>
<li><p>nosetests – path to nosetests to use</p></li>
<li><p>wlevel – the Python -W level</p></li>
<li><p>coverage – set <cite>coverage=html</cite> to get coverage report</p></li>
<li><p>pdb – set <cite>pdb=true</cite> to launch pdb on errors</p></li>
<li><p>module – run only specific test module</p></li>
<li><p>skip – skip tests by pattern</p></li>
<li><p>loop – number of test iterations for each module</p></li>
<li><p>report – url to submit reports to (see tests/collector.py)</p></li>
<li><p>worker – the worker id</p></li>
</ul>
<p>To run the full test cycle on the project, using a specific
python, making html coverage report:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo make test python=python3 coverage=html
</pre></div>
</div>
<p>To run a specific test module:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo make test module=general:test_ipdb.py:TestExplicit
</pre></div>
</div>
<p>The module parameter syntax:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>## module=package[:test_file.py[:TestClass[.test_case]]]

$ sudo make test module=lnst
$ sudo make test module=general:test_ipr.py
$ sudo make test module=general:test_ipdb.py:TestExplicit
</pre></div>
</div>
<p>There are several test packages:</p>
<ul class="simple">
<li><p>general – common functional tests</p></li>
<li><p>eventlet – Neutron compatibility tests</p></li>
<li><p>lnst – LNST compatibility tests</p></li>
</ul>
<p>For each package a new Python instance is launched, keep that
in mind since it affects the code coverage collection.</p>
<p>It is possible to skip tests by a pattern:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo make test skip=test_stress
</pre></div>
</div>
<p>To run tests in a loop, use the loop parameter:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo make test loop=10
</pre></div>
</div>
<p>For every iteration the code will be packed again with <cite>make dist</cite>
and checked against PEP8.</p>
<p>All the statistic may be collected with a simple web-script, see
<cite>tests/collector.py</cite> (requires the bottle framework). To retrieve
the collected data one can use curl:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo make test report=http://localhost:8080/v1/report/
$ curl http://localhost:8080/v1/report/ | python -m json.tool
</pre></div>
</div>
</div>
<div class="section" id="target-dist">
<h2>target: dist<a class="headerlink" href="#target-dist" title="Permalink to this headline">¶</a></h2>
<p>Make Python distribution package. Command line options:</p>
<ul class="simple">
<li><p>python – the Python to use</p></li>
</ul>
</div>
<div class="section" id="target-install">
<h2>target: install<a class="headerlink" href="#target-install" title="Permalink to this headline">¶</a></h2>
<p>Build and install the package into the system. Command line options:</p>
<ul class="simple">
<li><p>python – the Python to use</p></li>
<li><p>root – root install directory</p></li>
<li><p>lib – where to install lib files</p></li>
</ul>
</div>
<div class="section" id="target-develop">
<h2>target: develop<a class="headerlink" href="#target-develop" title="Permalink to this headline">¶</a></h2>
<p>Build the package and deploy the egg-link with setuptools. No code
will be deployed into the system directories, but instead the local
package directory will be visible to the python. In that case one
can change the code locally and immediately test it system-wide
without running <cite>make install</cite>.</p>
<ul class="simple">
<li><p>python – the Python to use</p></li>
</ul>
</div>
<div class="section" id="other-targets">
<h2>other targets<a class="headerlink" href="#other-targets" title="Permalink to this headline">¶</a></h2>
<p>Other targets are either utility targets to be used internally,
or hooks for related projects. You can safely ignore them.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Makefile documentation</a><ul>
<li><a class="reference internal" href="#target-clean">target: clean</a></li>
<li><a class="reference internal" href="#target-docs">target: docs</a></li>
<li><a class="reference internal" href="#target-test">target: test</a></li>
<li><a class="reference internal" href="#target-dist">target: dist</a></li>
<li><a class="reference internal" href="#target-install">target: install</a></li>
<li><a class="reference internal" href="#target-develop">target: develop</a></li>
<li><a class="reference internal" href="#other-targets">other targets</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="changelog.html"
                        title="previous chapter">Changelog</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="report.html"
                        title="next chapter">Report a bug</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/makefile.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="report.html" title="Report a bug"
             >next</a> |</li>
        <li class="right" >
          <a href="changelog.html" title="Changelog"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>